MainWindow = {}

-- Variables
MainWindow.Requests = {}
MainWindow.Height = 600
MainWindow.Width = 600

-- GUI Variables
MainWindow.Content = {}

function MainWindow.ShowHide()
    if(MainWindow.Window:IsShown()) then
         MainWindow.Window:Hide()
     else
          MainWindow.Window:Show()
    end 
end


-- Constructor
function MainWindow.Create(title, width, height)
    MainWindow.Height = height
    MainWindow.Width = width

    -- Create window
    MainWindow.Window = CreateFrame("Frame", title, UIParent, "BasicFrameTemplateWithInset");
    MainWindow.Window:SetMovable(true)
    MainWindow.Window:SetResizable(true)
    MainWindow.Window:EnableMouse(true)
    MainWindow.Window:RegisterForDrag("LeftButton")
    MainWindow.Window:SetScript("OnDragStart", MainWindow.Window.StartMoving)
    MainWindow.Window:SetScript("OnDragStop", MainWindow.Window.StopMovingOrSizing)
    MainWindow.Window:SetSize(width,height);
    MainWindow.Window:SetPoint("CENTER", UIParent, "CENTER");

    -- Title
    MainWindow.Window.title = MainWindow.Window:CreateFontString(nil, "OVERLAY", "GameFontHighlight");
    MainWindow.Window.title:SetPoint("LEFT", MainWindow.Window.TitleBg, "LEFT", 5,0);
    MainWindow.Window.title:SetText(title);

    -- Add Button
    MainWindow.Window.BtnInv = CreateFrame("Button", nil,  MainWindow.Window, "GameMenuButtonTemplate")
    MainWindow.Window.BtnInv:SetPoint("BOTTOMRIGHT",  MainWindow.Window, "BOTTOMRIGHT", -20,20)
    MainWindow.Window.BtnInv:SetSize(100,25)
    MainWindow.Window.BtnInv:SetText("Add Test")
    MainWindow.Window.BtnInv:SetScript("OnClick", function(self, BtnInv, down)
         MainWindow.AddUser("USER", "MESSAGE")
    end)

    -- Clear All Button
    MainWindow.Window.BtnClearAll = CreateFrame("Button", nil, MainWindow.Window, "GameMenuButtonTemplate")
    MainWindow.Window.BtnClearAll:SetPoint("BOTTOMLEFT", MainWindow.Window, "BOTTOMLEFT", 20, 20)
    MainWindow.Window.BtnClearAll:SetSize(100,25)
    MainWindow.Window.BtnClearAll:SetText("Clear All")
    MainWindow.Window.BtnClearAll:SetScript("OnClick", function(self)
     MainWindow.RemoveAllUsers()
    end)


    MainWindow.Window:RegisterEvent("CHAT_MSG_CHANNEL");

    -- Message event
    MainWindow.Window:SetScript("OnEvent", function(self,event, ...)
		    message,sender = ...;
		    messageLower = string.lower(message)
		
		    if string.match(messageLower, "portal") or string.match(messageLower, "port") or string.match(messageLower, "teleport") or string.match(messageLower, "mage")then
		  	    MainWindow.AddUser(sender, message)
		    end
    end);
end

function MainWindow.AddUser(username, message)
    request = {}
    request.Username = username
    request.Message = message
    table.insert(MainWindow.Requests, request)
    MainWindow.Draw()
end

function MainWindow.RemoveUser(index)

MainWindow.ClearDraw()
    table.remove(MainWindow.Requests, index)
    MainWindow.Draw()

end

function MainWindow.RemoveAllUsers()

MainWindow.ClearDraw()
for k,v in pairs(MainWindow.Requests) do MainWindow.Requests[k]=nil end
MainWindow.Draw()
end

function MainWindow.Draw()

    for i=1,table.getn(MainWindow.Requests),1 
    do 
       -- Frame
        local width = MainWindow.Width-20
        local height = 25

        frame = CreateFrame("Frame", "RequestFrame", MainWindow.Window)
        frame:SetPoint("TOP", MainWindow.Window, "TOP", 0, (-25*i)-10);
        frame:SetSize(width,height);

        -- Sender
        frame.Sender = frame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        frame.Sender:SetPoint("LEFT", frame, "LEFT")
        frame.Sender:SetSize(width/100*10,25)
        frame.Sender:SetText(MainWindow.Requests[i].Username)

         -- Message
        frame.Mesasage = frame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
        frame.Mesasage:SetPoint("LEFT", frame, "LEFT", width/100*10,0)
        frame.Mesasage:SetSize(width/100*70,25)
        frame.Mesasage:SetText(MainWindow.Requests[i].Message)

        -- Invite Button
        frame.BtnInvite = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate")
        frame.BtnInvite:SetPoint("LEFT", frame, "LEFT", width/100*80,0)
        frame.BtnInvite:SetSize(width/100*10,25)
        frame.BtnInvite:SetText("Invite")
        frame.BtnInvite.Data = MainWindow.Requests[i]
        frame.BtnInvite:SetScript("OnClick", function(self)
            InviteUnit(self.Data.Username)
        end)


        -- Delete Button
        frame.BtnDelete = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate")
        frame.BtnDelete:SetPoint("LEFT", frame, "LEFT", width/100*90,0)
        frame.BtnDelete:SetSize(width/100*10,25)
        frame.BtnDelete:SetText("Delete")
        frame.BtnDelete.Data = i
        frame.BtnDelete:SetScript("OnClick", function(self)
            MainWindow.RemoveUser(self.Data)
        end)

        table.insert(MainWindow.Content, frame)
    end
end
function MainWindow.ClearDraw()

    for i=1,table.getn(MainWindow.Content),1 
    do
        MainWindow.Content[i]:Hide()
    end
end